diff --git a/sys/dev/drm/nouveau/nouveau_bo.c b/sys/dev/drm/nouveau/nouveau_bo.c
index 01da508625..6f1d5d3834 100644
--- a/sys/dev/drm/nouveau/nouveau_bo.c
+++ b/sys/dev/drm/nouveau/nouveau_bo.c
@@ -27,6 +27,7 @@
  *	    Jeremy Kolb  <jkolb@brandeis.edu>
  */
 
+#include <drm/drmP.h>
 #include <linux/dma-mapping.h>
 #include <linux/swiotlb.h>
 
@@ -1197,9 +1198,9 @@ nouveau_bo_move(struct ttm_buffer_object *bo, bool evict, bool intr,
 	}
 
 	/* Fallback to software copy. */
-	spin_lock(&bo->bdev->fence_lock);
+	lockmgr(&bo->bdev->fence_lock, LK_EXCLUSIVE);
 	ret = ttm_bo_wait(bo, true, intr, no_wait_gpu);
-	spin_unlock(&bo->bdev->fence_lock);
+	lockmgr(&bo->bdev->fence_lock, LK_RELEASE);
 	if (ret == 0)
 		ret = ttm_bo_move_memcpy(bo, evict, no_wait_gpu, new_mem);
 
@@ -1441,10 +1442,10 @@ nouveau_bo_fence(struct nouveau_bo *nvbo, struct nouveau_fence *fence)
 	struct nouveau_fence *new_fence = nouveau_fence_ref(fence);
 	struct nouveau_fence *old_fence = NULL;
 
-	spin_lock(&nvbo->bo.bdev->fence_lock);
+	lockmgr(&nvbo->bo.bdev->fence_lock, LK_EXCLUSIVE);
 	old_fence = nvbo->bo.sync_obj;
 	nvbo->bo.sync_obj = new_fence;
-	spin_unlock(&nvbo->bo.bdev->fence_lock);
+	lockmgr(&nvbo->bo.bdev->fence_lock, LK_RELEASE);
 
 	nouveau_fence_unref(&old_fence);
 }
diff --git a/sys/dev/drm/nouveau/nouveau_bo.h b/sys/dev/drm/nouveau/nouveau_bo.h
index ff17c1f432..00035c7188 100644
--- a/sys/dev/drm/nouveau/nouveau_bo.h
+++ b/sys/dev/drm/nouveau/nouveau_bo.h
@@ -1,6 +1,8 @@
 #ifndef __NOUVEAU_BO_H__
 #define __NOUVEAU_BO_H__
 
+#include <drm/drm_gem.h>
+
 struct nouveau_channel;
 struct nouveau_fence;
 struct nouveau_vma;
diff --git a/sys/dev/drm/nouveau/nouveau_display.c b/sys/dev/drm/nouveau/nouveau_display.c
index 4a21b2b06c..cbfd9ca222 100644
--- a/sys/dev/drm/nouveau/nouveau_display.c
+++ b/sys/dev/drm/nouveau/nouveau_display.c
@@ -91,7 +91,7 @@ calc(int blanks, int blanke, int total, int line)
 	return line;
 }
 
-int
+static int
 nouveau_display_scanoutpos_head(struct drm_crtc *crtc, int *vpos, int *hpos,
 				ktime_t *stime, ktime_t *etime)
 {
@@ -648,13 +648,12 @@ nouveau_page_flip_emit(struct nouveau_channel *chan,
 	struct nouveau_fence_chan *fctx = chan->fence;
 	struct nouveau_drm *drm = chan->drm;
 	struct drm_device *dev = drm->dev;
-	unsigned long flags;
 	int ret;
 
 	/* Queue it to the pending list */
-	spin_lock_irqsave(&dev->event_lock, flags);
+	lockmgr(&dev->event_lock, LK_EXCLUSIVE);
 	list_add_tail(&s->head, &fctx->flip);
-	spin_unlock_irqrestore(&dev->event_lock, flags);
+	lockmgr(&dev->event_lock, LK_RELEASE);
 
 	/* Synchronize with the old framebuffer */
 	ret = nouveau_fence_sync(old_bo->bo.sync_obj, chan);
@@ -679,9 +678,9 @@ nouveau_page_flip_emit(struct nouveau_channel *chan,
 
 	return 0;
 fail:
-	spin_lock_irqsave(&dev->event_lock, flags);
+	lockmgr(&dev->event_lock, LK_EXCLUSIVE);
 	list_del(&s->head);
-	spin_unlock_irqrestore(&dev->event_lock, flags);
+	lockmgr(&dev->event_lock, LK_RELEASE);
 	return ret;
 }
 
@@ -718,9 +717,9 @@ nouveau_crtc_page_flip(struct drm_crtc *crtc, struct drm_framebuffer *fb,
 	mutex_lock(&cli->mutex);
 
 	/* synchronise rendering channel with the kernel's channel */
-	spin_lock(&new_bo->bo.bdev->fence_lock);
+	lockmgr(&new_bo->bo.bdev->fence_lock, LK_EXCLUSIVE);
 	fence = nouveau_fence_ref(new_bo->bo.sync_obj);
-	spin_unlock(&new_bo->bo.bdev->fence_lock);
+	lockmgr(&new_bo->bo.bdev->fence_lock, LK_RELEASE);
 	ret = nouveau_fence_sync(fence, chan);
 	nouveau_fence_unref(&fence);
 	if (ret)
@@ -801,14 +800,13 @@ nouveau_finish_page_flip(struct nouveau_channel *chan,
 	struct nouveau_drm *drm = chan->drm;
 	struct drm_device *dev = drm->dev;
 	struct nouveau_page_flip_state *s;
-	unsigned long flags;
 	int crtcid = -1;
 
-	spin_lock_irqsave(&dev->event_lock, flags);
+	lockmgr(&dev->event_lock, LK_EXCLUSIVE);
 
 	if (list_empty(&fctx->flip)) {
 		NV_ERROR(drm, "unexpected pageflip\n");
-		spin_unlock_irqrestore(&dev->event_lock, flags);
+		lockmgr(&dev->event_lock, LK_RELEASE);
 		return -EINVAL;
 	}
 
@@ -829,7 +827,7 @@ nouveau_finish_page_flip(struct nouveau_channel *chan,
 		*ps = *s;
 	kfree(s);
 
-	spin_unlock_irqrestore(&dev->event_lock, flags);
+	lockmgr(&dev->event_lock, LK_RELEASE);
 	return 0;
 }
 
diff --git a/sys/dev/drm/nouveau/nouveau_drm.c b/sys/dev/drm/nouveau/nouveau_drm.c
index 3ed32dd903..cee1c47c82 100644
--- a/sys/dev/drm/nouveau/nouveau_drm.c
+++ b/sys/dev/drm/nouveau/nouveau_drm.c
@@ -278,6 +278,7 @@ nouveau_accel_init(struct nouveau_drm *drm)
 	nouveau_bo_move_init(drm);
 }
 
+#ifndef __DragonFly__
 static int nouveau_drm_probe(struct pci_dev *pdev,
 			     const struct pci_device_id *pent)
 {
@@ -330,6 +331,7 @@ static int nouveau_drm_probe(struct pci_dev *pdev,
 
 	return 0;
 }
+#endif
 
 #define PCI_CLASS_MULTIMEDIA_HD_AUDIO 0x0403
 
@@ -386,7 +388,7 @@ nouveau_drm_load(struct drm_device *dev, unsigned long flags)
 	/* make sure AGP controller is in a consistent state before we
 	 * (possibly) execute vbios init tables (see nouveau_agp.h)
 	 */
-	if (pdev && drm_pci_device_is_agp(dev) && dev->agp) {
+	if (pdev && drm_device_is_agp(dev) && dev->agp) {
 		const u64 enables = NV_DEVICE_V0_DISABLE_IDENTIFY |
 				    NV_DEVICE_V0_DISABLE_MMIO;
 		/* dummy device object, doesn't init anything, but allows
@@ -532,6 +534,7 @@ nouveau_drm_device_remove(struct drm_device *dev)
 }
 EXPORT_SYMBOL(nouveau_drm_device_remove);
 
+#ifndef __DragonFly__
 static void
 nouveau_drm_remove(struct pci_dev *pdev)
 {
@@ -539,6 +542,7 @@ nouveau_drm_remove(struct pci_dev *pdev)
 
 	nouveau_drm_device_remove(dev);
 }
+#endif
 
 static int
 nouveau_do_suspend(struct drm_device *dev, bool runtime)
@@ -624,7 +628,7 @@ int nouveau_pmops_suspend(struct device *dev)
 	if (ret)
 		return ret;
 
-	pci_save_state(pdev);
+	pci_save_state(pdev->dev);
 	pci_disable_device(pdev);
 	pci_ignore_hotplug(pdev);
 	pci_set_power_state(pdev, PCI_D3hot);
@@ -676,7 +680,7 @@ int nouveau_pmops_resume(struct device *dev)
 		return 0;
 
 	pci_set_power_state(pdev, PCI_D0);
-	pci_restore_state(pdev);
+	pci_restore_state(pdev->dev);
 	ret = pci_enable_device(pdev);
 	if (ret)
 		return ret;
@@ -685,6 +689,7 @@ int nouveau_pmops_resume(struct device *dev)
 	return nouveau_do_resume(drm_dev, false);
 }
 
+#ifndef __DragonFly__
 static int nouveau_pmops_freeze(struct device *dev)
 {
 	struct pci_dev *pdev = to_pci_dev(dev);
@@ -698,6 +703,7 @@ static int nouveau_pmops_thaw(struct device *dev)
 	struct drm_device *drm_dev = pci_get_drvdata(pdev);
 	return nouveau_do_resume(drm_dev, false);
 }
+#endif
 
 
 static int
@@ -714,7 +720,7 @@ nouveau_drm_open(struct drm_device *dev, struct drm_file *fpriv)
 		return ret;
 
 	get_task_comm(tmpname, current);
-	snprintf(name, sizeof(name), "%s[%d]", tmpname, pid_nr(fpriv->pid));
+	ksnprintf(name, sizeof(name), "%s[%d]", tmpname, pid_nr(fpriv->pid));
 
 	ret = nouveau_cli_create(nouveau_name(dev), name, sizeof(*cli),
 			(void **)&cli);
@@ -815,6 +821,7 @@ nouveau_drm_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
 	return ret;
 }
 
+#ifndef __DragonFly__
 static const struct file_operations
 nouveau_driver_fops = {
 	.owner = THIS_MODULE,
@@ -829,6 +836,7 @@ nouveau_driver_fops = {
 #endif
 	.llseek = noop_llseek,
 };
+#endif
 
 static struct drm_driver
 driver = {
@@ -856,6 +864,7 @@ driver = {
 
 	.ioctls = nouveau_ioctls,
 	.num_ioctls = ARRAY_SIZE(nouveau_ioctls),
+#ifndef __DragonFly__
 	.fops = &nouveau_driver_fops,
 
 	.prime_handle_to_fd = drm_gem_prime_handle_to_fd,
@@ -869,6 +878,7 @@ driver = {
 	.gem_prime_import_sg_table = nouveau_gem_prime_import_sg_table,
 	.gem_prime_vmap = nouveau_gem_prime_vmap,
 	.gem_prime_vunmap = nouveau_gem_prime_vunmap,
+#endif
 
 	.gem_free_object = nouveau_gem_object_del,
 	.gem_open_object = nouveau_gem_object_open,
@@ -890,6 +900,7 @@ driver = {
 	.patchlevel = DRIVER_PATCHLEVEL,
 };
 
+#ifndef __DragonFly__
 static struct pci_device_id
 nouveau_drm_pci_table[] = {
 	{
@@ -928,7 +939,7 @@ static int nouveau_pmops_runtime_suspend(struct device *dev)
 	vga_switcheroo_set_dynamic_switch(pdev, VGA_SWITCHEROO_OFF);
 	nouveau_switcheroo_optimus_dsm();
 	ret = nouveau_do_suspend(drm_dev, true);
-	pci_save_state(pdev);
+	pci_save_state(pdev->dev);
 	pci_disable_device(pdev);
 	pci_set_power_state(pdev, PCI_D3cold);
 	drm_dev->switch_power_state = DRM_SWITCH_POWER_DYNAMIC_OFF;
@@ -946,7 +957,7 @@ static int nouveau_pmops_runtime_resume(struct device *dev)
 		return -EINVAL;
 
 	pci_set_power_state(pdev, PCI_D0);
-	pci_restore_state(pdev);
+	pci_restore_state(pdev->dev);
 	ret = pci_enable_device(pdev);
 	if (ret)
 		return ret;
@@ -1022,6 +1033,7 @@ nouveau_drm_pci_driver = {
 	.remove = nouveau_drm_remove,
 	.driver.pm = &nouveau_pm_ops,
 };
+#endif
 
 struct drm_device *
 nouveau_platform_device_create_(struct platform_device *pdev, int size,
@@ -1059,6 +1071,7 @@ err_free:
 }
 EXPORT_SYMBOL(nouveau_platform_device_create_);
 
+#ifndef __DragonFly__
 static int __init
 nouveau_drm_init(void)
 {
@@ -1090,6 +1103,6 @@ module_init(nouveau_drm_init);
 module_exit(nouveau_drm_exit);
 
 MODULE_DEVICE_TABLE(pci, nouveau_drm_pci_table);
+#endif
 MODULE_AUTHOR(DRIVER_AUTHOR);
 MODULE_DESCRIPTION(DRIVER_DESC);
-MODULE_LICENSE("GPL and additional rights");
diff --git a/sys/dev/drm/nouveau/nouveau_drm.h b/sys/dev/drm/nouveau/nouveau_drm.h
index b02b02452c..1f968177cb 100644
--- a/sys/dev/drm/nouveau/nouveau_drm.h
+++ b/sys/dev/drm/nouveau/nouveau_drm.h
@@ -40,7 +40,11 @@
 #include <drm/ttm/ttm_module.h>
 #include <drm/ttm/ttm_page_alloc.h>
 
+#ifdef __DragonFly__
+#include <uapi_drm/nouveau_drm.h>
+#else
 #include "uapi/drm/nouveau_drm.h"
+#endif
 
 struct nouveau_channel;
 struct platform_device;
@@ -80,7 +84,7 @@ struct nouveau_cli {
 	struct nvif_client base;
 	struct nouveau_vm *vm; /*XXX*/
 	struct list_head head;
-	struct mutex mutex;
+	struct lock mutex;
 	void *abi16;
 	struct list_head objects;
 	struct list_head notifys;
@@ -148,7 +152,7 @@ struct nouveau_drm {
 	/* nv10-nv40 tiling regions */
 	struct {
 		struct nouveau_drm_tile reg[15];
-		spinlock_t lock;
+		struct spinlock lock;
 	} tile;
 
 	/* modesetting */
@@ -163,7 +167,9 @@ struct nouveau_drm {
 	/* display power reference */
 	bool have_disp_power_ref;
 
+#if 0	/* PM_TODO */
 	struct dev_pm_domain vga_pm_domain;
+#endif
 	struct pci_dev *hdmi_device;
 };
 
diff --git a/sys/dev/drm/nouveau/nouveau_fence.c b/sys/dev/drm/nouveau/nouveau_fence.c
index 0a93114158..f2127adcd0 100644
--- a/sys/dev/drm/nouveau/nouveau_fence.c
+++ b/sys/dev/drm/nouveau/nouveau_fence.c
@@ -98,7 +98,7 @@ nouveau_fence_work(struct nouveau_fence *fence,
 	}
 
 	fctx = chan->fence;
-	work = kmalloc(sizeof(*work), GFP_KERNEL);
+	work = kmalloc(sizeof(*work), M_DRM, GFP_KERNEL);
 	if (!work) {
 		WARN_ON(nouveau_fence_wait(fence, false, false));
 		func(data);
@@ -270,7 +270,7 @@ nouveau_fence_wait(struct nouveau_fence *fence, bool lazy, bool intr)
 				sleep_time = NSEC_PER_MSEC;
 		}
 
-		if (intr && signal_pending(current)) {
+		if (intr && signal_pending(curthread->td_lwp)) {
 			ret = -ERESTARTSYS;
 			break;
 		}
diff --git a/sys/dev/drm/nouveau/nouveau_fence.h b/sys/dev/drm/nouveau/nouveau_fence.h
index c57bb61da5..12675188cc 100644
--- a/sys/dev/drm/nouveau/nouveau_fence.h
+++ b/sys/dev/drm/nouveau/nouveau_fence.h
@@ -38,7 +38,7 @@ struct nouveau_fence_chan {
 	int  (*emit32)(struct nouveau_channel *, u64, u32);
 	int  (*sync32)(struct nouveau_channel *, u64, u32);
 
-	spinlock_t lock;
+	struct spinlock lock;
 	u32 sequence;
 };
 
diff --git a/sys/dev/drm/nouveau/nouveau_gem.c b/sys/dev/drm/nouveau/nouveau_gem.c
index 292a677bfe..86e86f87a5 100644
--- a/sys/dev/drm/nouveau/nouveau_gem.c
+++ b/sys/dev/drm/nouveau/nouveau_gem.c
@@ -103,9 +103,9 @@ nouveau_gem_object_unmap(struct nouveau_bo *nvbo, struct nouveau_vma *vma)
 	list_del(&vma->head);
 
 	if (mapped) {
-		spin_lock(&nvbo->bo.bdev->fence_lock);
+		lockmgr(&nvbo->bo.bdev->fence_lock, LK_EXCLUSIVE);
 		fence = nouveau_fence_ref(nvbo->bo.sync_obj);
-		spin_unlock(&nvbo->bo.bdev->fence_lock);
+		lockmgr(&nvbo->bo.bdev->fence_lock, LK_RELEASE);
 	}
 
 	if (fence) {
@@ -433,9 +433,9 @@ validate_sync(struct nouveau_channel *chan, struct nouveau_bo *nvbo)
 	struct nouveau_fence *fence = NULL;
 	int ret = 0;
 
-	spin_lock(&nvbo->bo.bdev->fence_lock);
+	lockmgr(&nvbo->bo.bdev->fence_lock, LK_EXCLUSIVE);
 	fence = nouveau_fence_ref(nvbo->bo.sync_obj);
-	spin_unlock(&nvbo->bo.bdev->fence_lock);
+	lockmgr(&nvbo->bo.bdev->fence_lock, LK_RELEASE);
 
 	if (fence) {
 		ret = nouveau_fence_sync(fence, chan);
@@ -577,7 +577,7 @@ u_memcpya(uint64_t user, unsigned nmemb, unsigned size)
 
 	size *= nmemb;
 
-	mem = kmalloc(size, GFP_KERNEL | __GFP_NOWARN);
+	mem = kmalloc(size, M_DRM, GFP_KERNEL | __GFP_NOWARN);
 	if (!mem)
 		mem = vmalloc(size);
 	if (!mem)
@@ -659,9 +659,9 @@ nouveau_gem_pushbuf_reloc_apply(struct nouveau_cli *cli,
 				data |= r->vor;
 		}
 
-		spin_lock(&nvbo->bo.bdev->fence_lock);
+		lockmgr(&nvbo->bo.bdev->fence_lock, LK_EXCLUSIVE);
 		ret = ttm_bo_wait(&nvbo->bo, false, false, false);
-		spin_unlock(&nvbo->bo.bdev->fence_lock);
+		lockmgr(&nvbo->bo.bdev->fence_lock, LK_RELEASE);
 		if (ret) {
 			NV_PRINTK(error, cli, "reloc wait_idle failed: %d\n", ret);
 			break;
@@ -891,9 +891,9 @@ nouveau_gem_ioctl_cpu_prep(struct drm_device *dev, void *data,
 		return -ENOENT;
 	nvbo = nouveau_gem_object(gem);
 
-	spin_lock(&nvbo->bo.bdev->fence_lock);
+	lockmgr(&nvbo->bo.bdev->fence_lock, LK_EXCLUSIVE);
 	ret = ttm_bo_wait(&nvbo->bo, true, true, no_wait);
-	spin_unlock(&nvbo->bo.bdev->fence_lock);
+	lockmgr(&nvbo->bo.bdev->fence_lock, LK_RELEASE);
 	drm_gem_object_unreference_unlocked(gem);
 	return ret;
 }
diff --git a/sys/dev/drm/nouveau/nouveau_hwmon.c b/sys/dev/drm/nouveau/nouveau_hwmon.c
index afb36d66e7..b870a07565 100644
--- a/sys/dev/drm/nouveau/nouveau_hwmon.c
+++ b/sys/dev/drm/nouveau/nouveau_hwmon.c
@@ -23,7 +23,7 @@
  */
 
 #ifdef CONFIG_ACPI
-#include <linux/acpi.h>
+#include <contrib/dev/acpica/source/include/acpi.h>
 #endif
 #include <linux/power_supply.h>
 #include <linux/hwmon.h>
@@ -46,7 +46,7 @@ nouveau_hwmon_show_temp(struct device *d, struct device_attribute *a, char *buf)
 	if (temp < 0)
 		return temp;
 
-	return snprintf(buf, PAGE_SIZE, "%d\n", temp * 1000);
+	return ksnprintf(buf, PAGE_SIZE, "%d\n", temp * 1000);
 }
 static SENSOR_DEVICE_ATTR(temp1_input, S_IRUGO, nouveau_hwmon_show_temp,
 						  NULL, 0);
@@ -55,7 +55,7 @@ static ssize_t
 nouveau_hwmon_show_temp1_auto_point1_pwm(struct device *d,
 					 struct device_attribute *a, char *buf)
 {
-	return snprintf(buf, PAGE_SIZE, "%d\n", 100);
+	return ksnprintf(buf, PAGE_SIZE, "%d\n", 100);
 }
 static SENSOR_DEVICE_ATTR(temp1_auto_point1_pwm, S_IRUGO,
 			  nouveau_hwmon_show_temp1_auto_point1_pwm, NULL, 0);
@@ -68,7 +68,7 @@ nouveau_hwmon_temp1_auto_point1_temp(struct device *d,
 	struct nouveau_drm *drm = nouveau_drm(dev);
 	struct nouveau_therm *therm = nvkm_therm(&drm->device);
 
-	return snprintf(buf, PAGE_SIZE, "%d\n",
+	return ksnprintf(buf, PAGE_SIZE, "%d\n",
 	      therm->attr_get(therm, NOUVEAU_THERM_ATTR_THRS_FAN_BOOST) * 1000);
 }
 static ssize_t
@@ -101,7 +101,7 @@ nouveau_hwmon_temp1_auto_point1_temp_hyst(struct device *d,
 	struct nouveau_drm *drm = nouveau_drm(dev);
 	struct nouveau_therm *therm = nvkm_therm(&drm->device);
 
-	return snprintf(buf, PAGE_SIZE, "%d\n",
+	return ksnprintf(buf, PAGE_SIZE, "%d\n",
 	 therm->attr_get(therm, NOUVEAU_THERM_ATTR_THRS_FAN_BOOST_HYST) * 1000);
 }
 static ssize_t
@@ -133,7 +133,7 @@ nouveau_hwmon_max_temp(struct device *d, struct device_attribute *a, char *buf)
 	struct nouveau_drm *drm = nouveau_drm(dev);
 	struct nouveau_therm *therm = nvkm_therm(&drm->device);
 
-	return snprintf(buf, PAGE_SIZE, "%d\n",
+	return ksnprintf(buf, PAGE_SIZE, "%d\n",
 	       therm->attr_get(therm, NOUVEAU_THERM_ATTR_THRS_DOWN_CLK) * 1000);
 }
 static ssize_t
@@ -164,7 +164,7 @@ nouveau_hwmon_max_temp_hyst(struct device *d, struct device_attribute *a,
 	struct nouveau_drm *drm = nouveau_drm(dev);
 	struct nouveau_therm *therm = nvkm_therm(&drm->device);
 
-	return snprintf(buf, PAGE_SIZE, "%d\n",
+	return ksnprintf(buf, PAGE_SIZE, "%d\n",
 	  therm->attr_get(therm, NOUVEAU_THERM_ATTR_THRS_DOWN_CLK_HYST) * 1000);
 }
 static ssize_t
@@ -196,7 +196,7 @@ nouveau_hwmon_critical_temp(struct device *d, struct device_attribute *a,
 	struct nouveau_drm *drm = nouveau_drm(dev);
 	struct nouveau_therm *therm = nvkm_therm(&drm->device);
 
-	return snprintf(buf, PAGE_SIZE, "%d\n",
+	return ksnprintf(buf, PAGE_SIZE, "%d\n",
 	       therm->attr_get(therm, NOUVEAU_THERM_ATTR_THRS_CRITICAL) * 1000);
 }
 static ssize_t
@@ -229,7 +229,7 @@ nouveau_hwmon_critical_temp_hyst(struct device *d, struct device_attribute *a,
 	struct nouveau_drm *drm = nouveau_drm(dev);
 	struct nouveau_therm *therm = nvkm_therm(&drm->device);
 
-	return snprintf(buf, PAGE_SIZE, "%d\n",
+	return ksnprintf(buf, PAGE_SIZE, "%d\n",
 	  therm->attr_get(therm, NOUVEAU_THERM_ATTR_THRS_CRITICAL_HYST) * 1000);
 }
 static ssize_t
@@ -262,7 +262,7 @@ nouveau_hwmon_emergency_temp(struct device *d, struct device_attribute *a,
 	struct nouveau_drm *drm = nouveau_drm(dev);
 	struct nouveau_therm *therm = nvkm_therm(&drm->device);
 
-	return snprintf(buf, PAGE_SIZE, "%d\n",
+	return ksnprintf(buf, PAGE_SIZE, "%d\n",
 	       therm->attr_get(therm, NOUVEAU_THERM_ATTR_THRS_SHUTDOWN) * 1000);
 }
 static ssize_t
@@ -295,7 +295,7 @@ nouveau_hwmon_emergency_temp_hyst(struct device *d, struct device_attribute *a,
 	struct nouveau_drm *drm = nouveau_drm(dev);
 	struct nouveau_therm *therm = nvkm_therm(&drm->device);
 
-	return snprintf(buf, PAGE_SIZE, "%d\n",
+	return ksnprintf(buf, PAGE_SIZE, "%d\n",
 	  therm->attr_get(therm, NOUVEAU_THERM_ATTR_THRS_SHUTDOWN_HYST) * 1000);
 }
 static ssize_t
@@ -326,7 +326,7 @@ static ssize_t nouveau_hwmon_show_name(struct device *dev,
 				      struct device_attribute *attr,
 				      char *buf)
 {
-	return sprintf(buf, "nouveau\n");
+	return ksprintf(buf, "nouveau\n");
 }
 static SENSOR_DEVICE_ATTR(name, S_IRUGO, nouveau_hwmon_show_name, NULL, 0);
 
@@ -334,7 +334,7 @@ static ssize_t nouveau_hwmon_show_update_rate(struct device *dev,
 				      struct device_attribute *attr,
 				      char *buf)
 {
-	return sprintf(buf, "1000\n");
+	return ksprintf(buf, "1000\n");
 }
 static SENSOR_DEVICE_ATTR(update_rate, S_IRUGO,
 						nouveau_hwmon_show_update_rate,
@@ -348,7 +348,7 @@ nouveau_hwmon_show_fan1_input(struct device *d, struct device_attribute *attr,
 	struct nouveau_drm *drm = nouveau_drm(dev);
 	struct nouveau_therm *therm = nvkm_therm(&drm->device);
 
-	return snprintf(buf, PAGE_SIZE, "%d\n", therm->fan_sense(therm));
+	return ksnprintf(buf, PAGE_SIZE, "%d\n", therm->fan_sense(therm));
 }
 static SENSOR_DEVICE_ATTR(fan1_input, S_IRUGO, nouveau_hwmon_show_fan1_input,
 			  NULL, 0);
@@ -366,7 +366,7 @@ nouveau_hwmon_get_pwm1_enable(struct device *d,
 	if (ret < 0)
 		return ret;
 
-	return sprintf(buf, "%i\n", ret);
+	return ksprintf(buf, "%i\n", ret);
 }
 
 static ssize_t
@@ -405,7 +405,7 @@ nouveau_hwmon_get_pwm1(struct device *d, struct device_attribute *a, char *buf)
 	if (ret < 0)
 		return ret;
 
-	return sprintf(buf, "%i\n", ret);
+	return ksprintf(buf, "%i\n", ret);
 }
 
 static ssize_t
@@ -445,7 +445,7 @@ nouveau_hwmon_get_pwm1_min(struct device *d,
 	if (ret < 0)
 		return ret;
 
-	return sprintf(buf, "%i\n", ret);
+	return ksprintf(buf, "%i\n", ret);
 }
 
 static ssize_t
@@ -485,7 +485,7 @@ nouveau_hwmon_get_pwm1_max(struct device *d,
 	if (ret < 0)
 		return ret;
 
-	return sprintf(buf, "%i\n", ret);
+	return ksprintf(buf, "%i\n", ret);
 }
 
 static ssize_t
diff --git a/sys/dev/drm/nouveau/nouveau_nv10_fence.c b/sys/dev/drm/nouveau/nouveau_nv10_fence.c
index 4faaf0acf5..90455745b1 100644
--- a/sys/dev/drm/nouveau/nouveau_nv10_fence.c
+++ b/sys/dev/drm/nouveau/nouveau_nv10_fence.c
@@ -66,7 +66,7 @@ nv10_fence_context_del(struct nouveau_channel *chan)
 	kfree(fctx);
 }
 
-int
+static int
 nv10_fence_context_new(struct nouveau_channel *chan)
 {
 	struct nv10_fence_chan *fctx;
diff --git a/sys/dev/drm/nouveau/nouveau_nv50_display.c b/sys/dev/drm/nouveau/nouveau_nv50_display.c
index 03949eaa62..6ca6ac0248 100644
--- a/sys/dev/drm/nouveau/nouveau_nv50_display.c
+++ b/sys/dev/drm/nouveau/nouveau_nv50_display.c
@@ -22,9 +22,9 @@
  * Authors: Ben Skeggs
  */
 
+#include <drm/drmP.h>
 #include <linux/dma-mapping.h>
 
-#include <drm/drmP.h>
 #include <drm/drm_crtc_helper.h>
 #include <drm/drm_dp_helper.h>
 
@@ -173,7 +173,7 @@ struct nv50_dmac {
 	/* Protects against concurrent pushbuf access to this channel, lock is
 	 * grabbed by evo_wait (if the pushbuf reservation is successful) and
 	 * dropped again by evo_kick. */
-	struct mutex lock;
+	struct lock lock;
 };
 
 static void
@@ -1189,13 +1189,13 @@ nv50_crtc_lut_load(struct drm_crtc *crtc)
 		u16 b = nv_crtc->lut.b[i] >> 2;
 
 		if (disp->disp->oclass < GF110_DISP) {
-			writew(r + 0x0000, lut + (i * 0x08) + 0);
-			writew(g + 0x0000, lut + (i * 0x08) + 2);
-			writew(b + 0x0000, lut + (i * 0x08) + 4);
+			writew(r + 0x0000, (char *)lut + (i * 0x08) + 0);
+			writew(g + 0x0000, (char *)lut + (i * 0x08) + 2);
+			writew(b + 0x0000, (char *)lut + (i * 0x08) + 4);
 		} else {
-			writew(r + 0x6000, lut + (i * 0x20) + 0);
-			writew(g + 0x6000, lut + (i * 0x20) + 2);
-			writew(b + 0x6000, lut + (i * 0x20) + 4);
+			writew(r + 0x6000, (char *)lut + (i * 0x20) + 0);
+			writew(g + 0x6000, (char *)lut + (i * 0x20) + 2);
+			writew(b + 0x6000, (char *)lut + (i * 0x20) + 4);
 		}
 	}
 }
diff --git a/sys/dev/drm/nouveau/nouveau_nvif.c b/sys/dev/drm/nouveau/nouveau_nvif.c
index 47ca886237..f20bb7a2a4 100644
--- a/sys/dev/drm/nouveau/nouveau_nvif.c
+++ b/sys/dev/drm/nouveau/nouveau_nvif.c
@@ -42,7 +42,7 @@
 static void
 nvkm_client_unmap(void *priv, void *ptr, u32 size)
 {
-	iounmap(ptr);
+	iounmap(ptr, size);
 }
 
 static void *
diff --git a/sys/dev/drm/nouveau/nouveau_platform.c b/sys/dev/drm/nouveau/nouveau_platform.c
index 246a824c16..779d31c1c8 100644
--- a/sys/dev/drm/nouveau/nouveau_platform.c
+++ b/sys/dev/drm/nouveau/nouveau_platform.c
@@ -20,7 +20,9 @@
  * DEALINGS IN THE SOFTWARE.
  */
 
+#ifndef __DragonFly__
 #include <linux/clk.h>
+#endif
 #include <linux/io.h>
 #include <linux/module.h>
 #include <linux/platform_device.h>
@@ -180,4 +182,3 @@ module_platform_driver(nouveau_platform_driver);
 
 MODULE_AUTHOR(DRIVER_AUTHOR);
 MODULE_DESCRIPTION(DRIVER_DESC);
-MODULE_LICENSE("GPL and additional rights");
diff --git a/sys/dev/drm/nouveau/nouveau_prime.c b/sys/dev/drm/nouveau/nouveau_prime.c
index 1f51008e4d..5cf819e79e 100644
--- a/sys/dev/drm/nouveau/nouveau_prime.c
+++ b/sys/dev/drm/nouveau/nouveau_prime.c
@@ -27,6 +27,7 @@
 #include "nouveau_drm.h"
 #include "nouveau_gem.h"
 
+#ifndef __DragonFly__
 struct sg_table *nouveau_gem_prime_get_sg_table(struct drm_gem_object *obj)
 {
 	struct nouveau_bo *nvbo = nouveau_gem_object(obj);
@@ -109,3 +110,4 @@ struct reservation_object *nouveau_gem_prime_res_obj(struct drm_gem_object *obj)
 
 	return nvbo->bo.resv;
 }
+#endif
diff --git a/sys/dev/drm/nouveau/nouveau_sgdma.c b/sys/dev/drm/nouveau/nouveau_sgdma.c
index 01707e7dea..830b9d6b1f 100644
--- a/sys/dev/drm/nouveau/nouveau_sgdma.c
+++ b/sys/dev/drm/nouveau/nouveau_sgdma.c
@@ -1,3 +1,4 @@
+#include <drm/drmP.h>
 #include <linux/pagemap.h>
 #include <linux/slab.h>
 
diff --git a/sys/dev/drm/nouveau/nouveau_sysfs.c b/sys/dev/drm/nouveau/nouveau_sysfs.c
index 3c6962d15b..ebd93d616c 100644
--- a/sys/dev/drm/nouveau/nouveau_sysfs.c
+++ b/sys/dev/drm/nouveau/nouveau_sysfs.c
@@ -39,7 +39,7 @@ drm_device(struct device *d)
 }
 
 #define snappendf(p,r,f,a...) do {                                             \
-	snprintf(p, r, f, ##a);                                                \
+	ksnprintf(p, r, f, ##a);                                               \
 	r -= strlen(p);                                                        \
 	p += strlen(p);                                                        \
 } while(0)
diff --git a/sys/dev/drm/nouveau/nouveau_ttm.c b/sys/dev/drm/nouveau/nouveau_ttm.c
index 53874b76b0..06498d9dde 100644
--- a/sys/dev/drm/nouveau/nouveau_ttm.c
+++ b/sys/dev/drm/nouveau/nouveau_ttm.c
@@ -110,7 +110,7 @@ nouveau_vram_manager_debug(struct ttm_mem_type_manager *man, const char *prefix)
 
 	mutex_lock(&nv_subdev(pfb)->mutex);
 	list_for_each_entry(r, &mm->nodes, nl_entry) {
-		printk(KERN_DEBUG "%s %d: 0x%010llx 0x%010llx\n",
+		printk(KERN_DEBUG "%s %d: 0x%010lx 0x%010lx\n",
 		       prefix, r->type, ((u64)r->offset << 12),
 		       (((u64)r->offset + r->length) << 12));
 
@@ -120,7 +120,7 @@ nouveau_vram_manager_debug(struct ttm_mem_type_manager *man, const char *prefix)
 	}
 	mutex_unlock(&nv_subdev(pfb)->mutex);
 
-	printk(KERN_DEBUG "%s  total: 0x%010llx free: 0x%010llx\n",
+	printk(KERN_DEBUG "%s  total: 0x%010lx free: 0x%010lx\n",
 	       prefix, (u64)total << 12, (u64)free << 12);
 	printk(KERN_DEBUG "%s  block: 0x%08x\n",
 	       prefix, mm->block_size << 12);
diff --git a/sys/dev/drm/nouveau/nouveau_usif.c b/sys/dev/drm/nouveau/nouveau_usif.c
index cb1182d7e8..d56b587e0e 100644
--- a/sys/dev/drm/nouveau/nouveau_usif.c
+++ b/sys/dev/drm/nouveau/nouveau_usif.c
@@ -106,13 +106,13 @@ usif_notify(const void *header, u32 length, const void *data, u32 size)
 		break;
 	}
 
-	spin_lock_irqsave(&dev->event_lock, flags);
+	lockmgr(&dev->event_lock, LK_EXCLUSIVE);
 	if (!WARN_ON(filp->event_space < ntfy->p->e.base.length)) {
 		list_add_tail(&ntfy->p->base.link, &filp->event_list);
 		filp->event_space -= ntfy->p->e.base.length;
 	}
 	wake_up_interruptible(&filp->event_wait);
-	spin_unlock_irqrestore(&dev->event_lock, flags);
+	lockmgr(&dev->event_lock, LK_RELEASE);
 	atomic_set(&ntfy->enabled, 0);
 	return NVIF_NOTIFY_DROP;
 }
@@ -138,7 +138,7 @@ usif_notify_new(struct drm_file *f, void *data, u32 size, void *argv, u32 argc)
 		return ret;
 	req = data;
 
-	if (!(ntfy = kmalloc(sizeof(*ntfy), GFP_KERNEL)))
+	if (!(ntfy = kmalloc(sizeof(*ntfy), M_DRM, GFP_KERNEL)))
 		return -ENOMEM;
 	atomic_set(&ntfy->enabled, 0);
 
@@ -204,7 +204,7 @@ usif_notify_get(struct drm_file *f, void *data, u32 size, void *argv, u32 argc)
 	if (atomic_xchg(&ntfy->enabled, 1))
 		return 0;
 
-	ntfy->p = kmalloc(sizeof(*ntfy->p) + ntfy->reply, GFP_KERNEL);
+	ntfy->p = kmalloc(sizeof(*ntfy->p) + ntfy->reply, M_DRM, GFP_KERNEL);
 	if (ret = -ENOMEM, !ntfy->p)
 		goto done;
 	ntfy->p->base.event = &ntfy->p->e.base;
@@ -271,7 +271,7 @@ usif_object_new(struct drm_file *f, void *data, u32 size, void *argv, u32 argc)
 	struct usif_object *object;
 	int ret;
 
-	if (!(object = kmalloc(sizeof(*object), GFP_KERNEL)))
+	if (!(object = kmalloc(sizeof(*object), M_DRM, GFP_KERNEL)))
 		return -ENOMEM;
 	list_add(&object->head, &cli->objects);
 
@@ -295,7 +295,7 @@ usif_ioctl(struct drm_file *filp, void __user *user, u32 argc)
 {
 	struct nouveau_cli *cli = nouveau_cli(filp);
 	struct nvif_client *client = &cli->base;
-	void *data = kmalloc(argc, GFP_KERNEL);
+	void *data = kmalloc(argc, M_DRM, GFP_KERNEL);
 	u32   size = argc;
 	union {
 		struct nvif_ioctl_v0 v0;
diff --git a/sys/dev/drm/nouveau/nv10_fence.h b/sys/dev/drm/nouveau/nv10_fence.h
index a87259f398..453ff86bb5 100644
--- a/sys/dev/drm/nouveau/nv10_fence.h
+++ b/sys/dev/drm/nouveau/nv10_fence.h
@@ -13,7 +13,7 @@ struct nv10_fence_chan {
 struct nv10_fence_priv {
 	struct nouveau_fence_priv base;
 	struct nouveau_bo *bo;
-	spinlock_t lock;
+	struct spinlock lock;
 	u32 sequence;
 };
 
diff --git a/sys/dev/drm/nouveau/nvif/nouveau_nvif_notify.c b/sys/dev/drm/nouveau/nvif/nouveau_nvif_notify.c
index 0898c31552..3cf875d944 100644
--- a/sys/dev/drm/nouveau/nvif/nouveau_nvif_notify.c
+++ b/sys/dev/drm/nouveau/nvif/nouveau_nvif_notify.c
@@ -128,7 +128,7 @@ nvif_notify(const void *header, u32 length, const void *data, u32 size)
 		if (!WARN_ON(notify->size != size)) {
 			atomic_inc(&notify->putcnt);
 			if (test_bit(NVIF_NOTIFY_WORK, &notify->flags)) {
-				memcpy((void *)notify->data, data, size);
+				memcpy(__DECONST(void *, notify->data), data, size);
 				schedule_work(&notify->work);
 				return NVIF_NOTIFY_DROP;
 			}
@@ -157,7 +157,7 @@ nvif_notify_fini(struct nvif_notify *notify)
 		ret = nvif_object_ioctl(object, &args, sizeof(args), NULL);
 		if (ret == 0) {
 			nvif_object_ref(NULL, &notify->object);
-			kfree((void *)notify->data);
+			kfree(__DECONST(void *, notify->data));
 		}
 	}
 	return ret;
@@ -186,12 +186,12 @@ nvif_notify_init(struct nvif_object *object, void (*dtor)(struct nvif_notify *),
 	if (work) {
 		INIT_WORK(&notify->work, nvif_notify_work);
 		set_bit(NVIF_NOTIFY_WORK, &notify->flags);
-		notify->data = kmalloc(notify->size, GFP_KERNEL);
+		notify->data = kmalloc(notify->size, M_DRM, GFP_KERNEL);
 		if (!notify->data)
 			goto done;
 	}
 
-	if (!(args = kmalloc(sizeof(*args) + size, GFP_KERNEL)))
+	if (!(args = kmalloc(sizeof(*args) + size, M_DRM, GFP_KERNEL)))
 		goto done;
 	args->ioctl.version = 0;
 	args->ioctl.type = NVIF_IOCTL_V0_NTFY_NEW;
diff --git a/sys/dev/drm/nouveau/nvif/nouveau_nvif_object.c b/sys/dev/drm/nouveau/nvif/nouveau_nvif_object.c
index dd85b56f6a..f2880fb62d 100644
--- a/sys/dev/drm/nouveau/nvif/nouveau_nvif_object.c
+++ b/sys/dev/drm/nouveau/nvif/nouveau_nvif_object.c
@@ -60,7 +60,7 @@ nvif_object_sclass(struct nvif_object *object, u32 *oclass, int count)
 	u32 size = count * sizeof(args->sclass.oclass[0]);
 	int ret;
 
-	if (!(args = kmalloc(sizeof(*args) + size, GFP_KERNEL)))
+	if (!(args = kmalloc(sizeof(*args) + size, M_DRM, GFP_KERNEL)))
 		return -ENOMEM;
 	args->ioctl.version = 0;
 	args->ioctl.type = NVIF_IOCTL_V0_SCLASS;
@@ -123,7 +123,7 @@ nvif_object_mthd(struct nvif_object *object, u32 mthd, void *data, u32 size)
 	int ret;
 
 	if (sizeof(*args) + size > sizeof(stack)) {
-		if (!(args = kmalloc(sizeof(*args) + size, GFP_KERNEL)))
+		if (!(args = kmalloc(sizeof(*args) + size, M_DRM, GFP_KERNEL)))
 			return -ENOMEM;
 	} else {
 		args = (void *)stack;
@@ -235,7 +235,7 @@ nvif_object_init(struct nvif_object *parent, void (*dtor)(struct nvif_object *),
 	object->map.size = 0;
 
 	if (object->parent) {
-		if (!(ctor = kmalloc(sizeof(*ctor) + size, GFP_KERNEL))) {
+		if (!(ctor = kmalloc(sizeof(*ctor) + size, M_DRM, GFP_KERNEL))) {
 			nvif_object_fini(object);
 			return -ENOMEM;
 		}
